
#include <stdio.h>
#include "Color.h"



ColorMap::ColorMap(int size)
{
	ncolors = size;
	nred = ngreen = nblue = 1;
	while(true) {
		nred++;
		if(nred*(ngreen+1)*nblue > ncolors)
			break;
		ngreen++;
		if(nred*ngreen*(nblue+1) > ncolors)
			break;
		nblue++;
		if((nred+1)*ngreen*nblue > ncolors)
			break;
	}	
	ncolors = nred*ngreen*nblue;
	printf("red/green/blue= %d/%d/%d (%d)\n",
		nred, ngreen, nblue, ncolors);
	col = new Color[ncolors];
	pix = new int[ncolors];
	int i;
	for(i=0; i<size; i++) {
		ired[i] = (i*(nred-1))/256;
		igreen[i] = (i*(ngreen-1))/256;
		iblue[i] = (i*(nblue-1))/256;
		pred[i] = (i-(ired[i]*256)/(nred-1))*(nred-1);
		pgreen[i] = (i-(igreen[i]*256)/(ngreen-1))*(ngreen-1);
		pblue[i] = (i-(iblue[i]*256)/(nblue-1))*(nblue-1);
	}
	for(i=0; i<ncolors; i++) {
		col[i].red = ((i/(nblue*ngreen))*65535)/nred;
		col[i].green = (((i/nblue)%ngreen)*65535)/ngreen;
		col[i].blue = ((i%nblue)*65535)/nblue;
		pix[i] = i;
	}
}


ColorMap::~ColorMap()
{
	delete[] col;
	delete[] pix;
}

