// IVertex.h

#ifndef __IVertex_h__
#define __IVertex_h__

#include "types.h"
#include "IVector.h"
#include "Color.h"

#define MAXSIDES 10


class IVertex : public IVector, public Color {
public:
	IVertex() {}
	IVertex(IVector &v)		{ *(IVector*)this = v; }
	IVertex& operator=(IVector &v)	{ *(IVector*)this = v; return *this; }
	IVertex(Color &c)		{ *(Color*)this = c; }
	IVertex& operator=(Color &c)	{ *(Color*)this = c; return *this; }
	IVertex(ivec_t x, ivec_t y, ivec_t z,
		ushort red, ushort green, ushort blue)
			: IVector(x, y, z), Color(red, green, blue) {}
};

#endif

