
#ifndef __Membuf_h__
#define __Membuf_h__


#include "types.h"

#define DEFAULT_BUFSIZE	262144


class Membuf {
	uchar	*buf;
	int	bufsize;
	int	rpos;
	int	wpos;
public:
	Membuf(void *adr, int size) {
		buf = (uchar*)adr;
		bufsize = size;
		rpos = wpos = 0; }
	virtual ~Membuf() {}
	int read(void *adr, int size);
	int write(void *adr, int size);
	void flush();
	bool can_read();
	virtual int read_block(void *adr, int size) = 0;
	virtual int write_block(void *adr, int size) = 0;
	virtual bool can_read_block() = 0;
	virtual bool ok() = 0;
	void error();
	void write(char n)	{ write(&n, sizeof(n)); }
	void write(uchar n)	{ write(&n, sizeof(n)); }
	void write(short n)	{ write(&n, sizeof(n)); }
	void write(ushort n)	{ write(&n, sizeof(n)); }
	void write(long n)	{ write(&n, sizeof(n)); }
	void write(ulong n)	{ write(&n, sizeof(n)); }
	void read(char &n)	{ if(!read(&n, sizeof(n))) error(); }
	void read(uchar &n)	{ if(!read(&n, sizeof(n))) error(); }
	void read(short &n)	{ if(!read(&n, sizeof(n))) error(); }
	void read(ushort &n)	{ if(!read(&n, sizeof(n))) error(); }
	void read(long &n)	{ if(!read(&n, sizeof(n))) error(); }
	void read(ulong &n)	{ if(!read(&n, sizeof(n))) error(); }
};


class Membuf_fd : public Membuf {
	int	fd;
	uchar	*buf;
public:
	Membuf_fd(int newfd, int size = DEFAULT_BUFSIZE);
	Membuf_fd(char *fname, int size = DEFAULT_BUFSIZE);
	~Membuf_fd();
	int read_block(void *adr, int size);
	int write_block(void *adr, int size);
	bool can_read_block();
	bool ok()	{ return fd >= 0; }
};


#endif

