// Obj3d.h

#ifndef __Obj3d_h__
#define __Obj3d_h__


#include "types.h"
#include "Vector.h"
#include "Matrix.h"
#include "Eye.h"
#include <stdio.h>

class Obj3d {
public:
	const int id;
	IVector	pos;
	IVector	vel;
	short	roll,pitch,yaw;
	short	vroll,vpitch,vyaw;
	Obj3d(int newid) : id(newid) {
				  pos = vel = 0;
				  roll = pitch = yaw = 0;
				  vroll = vpitch = vyaw = 0; }
	Matrix4x4 translate(Matrix4x4 &tm) {
		return tm*Matrix4x4(-pos)
			*Matrix_Rotate_y(yaw)
			*Matrix_Rotate_x(pitch)
			*Matrix_Rotate_z(roll);
	}
	virtual void render(Eye &e, Vector &light) {}
	virtual void update(int msec);
	virtual ~Obj3d() {};
};

#endif

