// ObjTable.h
//	table of 3-d objects to draw
//	currently organized as a doubly-linked list
//	should later be a tree


#ifndef __ObjTable_h__
#define __ObjTable_h__


#include "types.h"
#include "Vector.h"
#include "Matrix.h"
#include "Eye.h"
#include "Obj3d.h"


class Obj3dNode {
	friend class	Obj3dTable;
	friend class	Obj3dIterator;
	Obj3d		*obj;
	Obj3dNode	*next;
	Obj3dNode	*prev;
public:
	Obj3dNode(Obj3d *op) { obj = op; next = 0; prev = 0; }
};


class Obj3dTable {
	Obj3dNode *head;
	friend class Obj3dIterator;
public:
	Obj3dTable()		{ head = 0; }
	~Obj3dTable();
	Obj3d* operator[] (int id);
	void insert(Obj3d *o);
	void remove(Obj3d *o);
	void remove(int id)	{ remove((*this)[id]); }
};


class Obj3dIterator {
	Obj3dNode *ptr;
public:
	Obj3dIterator(Obj3dTable &ot) { ptr = ot.head; }
	operator Obj3d* ()
		{ if(ptr) return ptr->obj; else return 0; }
	Obj3d* operator++()
		{ if(ptr) ptr = ptr->next; return ptr->obj; }
	Obj3d* operator++(int) {
		Obj3d* obj;
		if(ptr)
			{ obj = ptr->obj; ptr = ptr->next; return obj; }
		else return obj; }
};


#endif


