// Poly3d.h


#ifndef __Poly3d_h__
#define __Poly3d_h__

#include "types.h"
#include "Color.h"
#include "Vector.h"
#include "Vertex.h"
#include "Matrix.h"
#include "Obj3d.h"



class Poly3d : public Obj3d {
protected:
	int	npoints;	// number of points
	int	npoly;	// number of polygons
	int	nvert;		// number of vertices
	Vertex	*vert;		// points and point colors
	Vertex 	*trans;		// translated vertex points and colors
	Color	*color;		// color for polygon surfaces
	ushort	*polysize;	// number of sides for each polygon
	ushort	**poly;		// start of vertex table for each polygon
	Poly3d(int id) : Obj3d(id) {}
	bool	smooth;		// use vertex colors instead of surface colors
public:
	Poly3d(int id, int points, int polys, int nvert);
	~Poly3d();
	void render(Eye &e, Vector &light);
};

#endif

