
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>
#include "types.h"
#include "Screen.h"
#include "Vfx1.h"


int Screen::planemask = 0;
int Screen::vbase = 0;
int Screen::vofs = 0;
int Screen::page = 0;
int Screen::pagebase[4];


struct VidMode {
	int	mode;
	int	wid;
	int	hgt;
	bool	mode_x;
};

VidMode vidmode[] = {
	{ G320x200x256, 320, 200, false },
	{ G320x240x256, 320, 240, false },
	{ G640x480x256, 1280, 240, true }
};



Screen::Screen()
{
int mode = 1;
vga_modeinfo *modeinfo;
	vga_init();
	vga_setmousesupport(true);
	vga_setmode(vidmode[mode].mode);
	printf("done mode init\n"); fflush(stdout);
	// if(vidmode[mode].mode_x)
	vga_setmodeX(); 
	wid = vidmode[mode].wid;
	hgt = vidmode[mode].hgt;
	gl_setcontextvga(vidmode[mode].mode);
	cmap = new ColorMap(256);
	for(int i=0; i<cmap->size(); i++) {
		gl_setpalettecolor(i,
			cmap->color(i).red/1024,
			cmap->color(i).green/1024,
			cmap->color(i).blue/1024);
		vfx1.set_palette(i,
			cmap->color(i).red/1024,
			cmap->color(i).green/1024,
			cmap->color(i).blue/1024);
		cmap->pixel(i) = i;
	}
	vfx1.video_init(false);
	
	font = new uchar[256*8*8*BYTESPERPIXEL];
	gl_expandfont(8, 8, cmap->match(Color(65535,65535,65535)),
			gl_font8x8, font);
	gl_setfont(8, 8, font);
	gl_setwritemode(WRITEMODE_OVERWRITE);

	modeinfo = vga_getmodeinfo(mode);
	vidmem = (Pixel*)vga_getgraphmem();

/*
	while(1) {
		int a,v,n;
		scanf("%d%d%d", &a, &n, &v);
		while(n--)
		vidmem[a++] = v;
	}
*/
#ifdef STEREO
	vpitch = wid;
#else
	vpitch = wid/4;
#endif
	framesize = vpitch*hgt;
	if(wid > 320) {
		pagebase[0] = 0;
		pagebase[1] = vpitch/4;
		pagebase[2] = vpitch/2;
		pagebase[3] = vpitch*3/4;
	} else {
		pagebase[0] = 0;
		pagebase[1] = framesize;
		pagebase[2] = framesize*2;
		pagebase[3] = framesize*3;
	}
	printf("done frame init\n"); fflush(stdout);
	mouse_init("/dev/mouse", MOUSE_PS2, MOUSE_DEFAULTSAMPLERATE);
	mouse_setxrange(0, wid-1);
	mouse_setyrange(0, hgt-1);
	mouse_setwrap(MOUSE_NOWRAP);
	mouse_setposition(wid/2, hgt/2);
	printf("page: %x,%x,%x,%x\n",
		pagebase[0],pagebase[1],pagebase[2],pagebase[3]);
	write(0, 0, 232, "page 0");
	write(1, 0, 232, "page 1");
	write(2, 0, 232, "page 2");
	vga_unlockvc();
	printf("done init\n"); fflush(stdout);
}


Screen::~Screen()
{
	delete cmap;
	mouse_close();
	vga_setmode(TEXT);
	printf("\n");
}

int Screen::get_key()
{
	return vga_getkey();
}


bool Screen::read_mouse(mouse_state *mouse)
{
	mouse->oldx = mouse->x;
	mouse->oldy = mouse->y;
	mouse->oldbutton[0] = mouse->button[0];
	mouse->oldbutton[1] = mouse->button[1];
	mouse->oldbutton[2] = mouse->button[2];
	printf("mouse update\n");
	mouse_update();
	mouse->x = mouse_getx();
	mouse->y = mouse_gety();
	printf("mouse: %d %d\n", mouse->x, mouse->y);
	int but = mouse_getbutton();
	mouse->button[0] = but & MOUSE_LEFTBUTTON;
	mouse->button[1] = but & MOUSE_MIDDLEBUTTON;
	mouse->button[2] = but & MOUSE_RIGHTBUTTON;
	return true;
}

void Screen::write(int page, int x, int y, char *s, int c0, int cinc)
{
Pixel *vp = vidmem+vpitch*y+x*2+pagebase[page];
static uchar reverse[16] = {0x0,0x8,0x4,0xc,0x2,0xa,0x6,0xe,
			    0x1,0x9,0x5,0xd,0x3,0xb,0x7,0xf};
	while(*s) {
		uchar *fp = gl_font8x8+(*s)*8;
		int vofs = 0;
		for(y=0; y<8; y++) {
			set_mask(0xf); vp[vofs] = 0; vp[vofs+1] = 0;
			set_mask(reverse[*fp >> 4]); vp[vofs] = c0;
			set_mask(reverse[*fp & 0xf]); vp[vofs+1] = c0;
			fp++;
			vofs += vpitch;
			if((c0 += cinc) >= 252)
				c0 -= 252;
		}
		vp += 2; s++; 
	}
}

