// Slope.h


#ifndef __Slope_h__
#define __Slope_h__

#include "types.h"


class Slope {
	int	y;
	int	d;
	int	incr[2];
	int	yinc[2];
public:
	Slope() { }
	Slope(int y1, int y2, int dx) {
		int dy;
		y = y1;
		yinc[0] = 0;
		if(dx <= 0)
			return;
		if(y2>y1) {
			dy = y2-y1;
			if(dy>dx) {
				yinc[0] = dy/dx;
				dy -= yinc[0]*dx;
			}
			yinc[1] = yinc[0]+1;
		} else {
			dy = y1-y2;
			if(dy>dx) {
				yinc[0] = dy/dx;
				dy -= yinc[0]*dx;
				yinc[0] = -yinc[0];
			}
			yinc[1] = yinc[0]-1;
		}
		incr[0] = dy+dy;
		d = incr[0]-dx;
		incr[1] = d-dx;
	}
	int operator++() {
		y += yinc[d >= 0];
		d += incr[d >= 0];
		return y;
	}
	int operator++(int) {
		int oldy = y;
		++(*this);
		return oldy;
	}
	operator int()	{ return y; }
};

/*
class uSlope {
	int	y;
	int	d;
	int	incr1,incr2;
	int	yinc;
	int	ydir;
public:
	uSlope() { }
	uSlope(uint y1, uint y2, uint dx) {
		uint dy;
		if(y2>y1) {
			dy = y2-y1;
			if(dy>dx) {
				yinc = dy/dx;
				dy -= yinc*dx;
			}
			ydir = 1;
		} else {
			dy = y1-y2;
			if(dy>dx) {
				yinc = -(dy/dx);
				dy += yinc*dx;
			}
			ydir = -1;
		}	
		incr1 = dy+dy;
		d = incr1-dx;
		incr2 = d-dx;
		ydir += yinc;
	}
	uint operator++() {
		if(d < 0) {
			y += yinc;
			d += incr1;
		} else {
			y += ydir;
			d += incr2;
		}
		return y;
	}
	uint operator++(int) {
		uint oldy = y;
		++(*this);
		return oldy;
	}
	operator uint()	{ return y; }
};
*/

typedef Slope uSlope;

#endif

