
#ifndef __Vfx1_h__
#define __Vfx1_h__


#include "math.h"
#include "Vfx1Event.h"


#define VIP_SCR		0
#define VIP_SSR		1
#define VIP_ICR		2
#define VIP_ISR		3
#define VIP_PSR		4
#define VIP_VRR		5
#define VIP_PCR		6
#define VIP_PPMR	7
#define VIP_PRAR	8
#define VIP_PWAR	9
#define VIP_PCRR	10

#define VIP_VTIM1	0
#define VIP_VTIM2	1
#define VIP_VTIM3	2


class Vfx1 {
	int	vip_air_port;
	int	vip_acr_port;
	int	vip_fir_port;
	int	vip_fcr_port;
	int	devfd;
	VFXEvent vfx;
public:
	Vfx1();
	void set_palette(int i, int red, int green, int blue);
	void set_page(int p) {
		outb(vip_air_port, VIP_PSR);
		outb(vip_acr_port, p); }
	void set_ihdelay(int n) {
		outb(vip_fir_port, VIP_VTIM1);
		outb(vip_fcr_port, n); }
	void set_ohdelay(int n) {
		outb(vip_fir_port, VIP_VTIM2);
		outb(vip_fcr_port, n); }
	void video_init(bool stereo);
	bool hmd_puck_update();
	short hmd_yaw()
		{ return iatan2(vfx.hmd.y-8192, vfx.hmd.x-8192); }
	short hmd_x()	    { return vfx.hmd.x-8192; }
	short hmd_y()	    { return vfx.hmd.y-8192; }
	short hmd_pitch()  { return vfx.hmd.pitch-8192; }
	short hmd_roll()   { return vfx.hmd.roll-8192; }
	short puck_pitch() { return vfx.puck.pitch-8192; }
	short puck_roll()  { return vfx.puck.roll-8192; }
	bool puck_button(int b)	{ return vfx.puck.buttons & (1 << b); }
};


extern Vfx1 vfx1;


#endif

