// ioport.h

#ifndef __ioport_h__
#define __ioport_h__


#include "types.h"



static inline void outb(register int port, register int value)
{
	__asm__ volatile ("outb %0,%1"
		: : "a" ((uchar)value), "d" ((ushort)port));
}

static inline void outw(register int port, register int value) {
	__asm__ volatile("outw %0,%1"
		: : "a" ((ushort)value), "d" ((ushort)port));
}

static inline int inb(register int port)
{
	register uchar value;
	__asm__ volatile ("inb %1,%0" : "=a" (value) : "d" ((ushort)port));
	return value;
}

static inline int inw(register int port)
{
	register ushort value;
	__asm__ volatile ("inw %1,%0"
		: "=a" (value)
		: "d" ((ushort)port));
	return value;
}


#endif
