// math.h

#ifndef __math_h__
#define __math_h__

#include <math.h>

typedef short angle_t;

#define ANG_ITOD	(M_PI/32767.0)
#define ANG_DTOI	(32767.0/M_PI)

static inline double dcos(angle_t n) { return cos(n*ANG_ITOD); }
static inline double dsin(angle_t n) { return sin(n*ANG_ITOD); }
static inline int icos(angle_t n) { return int(32767.0*cos(n*ANG_ITOD)); }
static inline int isin(angle_t n) { return int(32767.0*sin(n*ANG_ITOD)); }
static inline int icos(angle_t n, int scale)
	{ return int(double(scale)*cos(n*ANG_ITOD)); }
static inline int isin(angle_t n, int scale)
	{ return int(double(scale)*sin(n*ANG_ITOD)); }

static inline double dsqrt(double n) { return sqrt(n); }
static inline short datan2(double x, double y)
		{ return short(atan2(x,y)*ANG_DTOI); }
static inline short iatan2(int x, int y)
		{ return short(atan2(double(x),double(y))*ANG_DTOI); }

#endif
