// sr3d.C

#include <unistd.h>
#include <stdio.h>
#include <sys/time.h>
#include <string.h>
#include "types.h"
#include "IVertex.h"
#include "ViewPort.h"
#include "sr3d.h"
#include "ObjTable.h"
#include "Poly3d.h"
#include "Off3d.h"
#include "Vfx1.h"
#include "math.h"


void sr3d(Membuf *mbuf, char *objname)
{
int i = 0;
Screen screen;
ViewPort viewport(screen, 0, 0, 320, 224);
int f;
int num = 0;
Obj3dTable objtable;
mouse_state mouse;
Eye eye;
Vector light = Vector(1,-5,-4).normalize();
int tcolor = 0;
char buf[100];
char msg[] = "                                        "
	"This is a work in progress... there will be improvements every "
	"day, probably several times a day, so come back each day to "
	"check out what's new...                                        ";
int mpos = 0;
int msize = sizeof(msg);

	viewport.set_wireframe(false);
	viewport.set_gourad(true);
	viewport.set_dither(true);
	viewport.set_zbuf(true);
	f = viewport.fps_x1000();

	printf("loading obj\n");
	
	{
		Obj3d *obj;
		obj = new Obj3d(0x0);
		obj->pos = Vector(0,0,0);
		obj->vel = Vector(0,0,0.1);
		eye.set_object(obj);
		objtable.insert(obj);
		if(objname) {
			char b1[100], b2[100];
			sprintf(b1, "%s.geom", objname);
			sprintf(b2, "%s.ipcol", objname);
			obj = new Off3d(0xdeadbeef, 100,
				&Membuf_fd(b1),
				&Membuf_fd(b2));
			obj->pos = Vector(0, 0, 200);
			obj->vel = Vector(0, 0, 0);
			obj->vyaw = 3000;
			obj->vpitch = 1000;
			objtable.insert(obj);
		}  	
//			obj = new Off3d(0xcafebabe, 100,
//				&Membuf_fd("obj/cow.geom"),
//				&Membuf_fd("obj/cow.ipcol"));
//		obj->pos = Vector(0, 100, 200);
//		obj->vel = Vector(0, 0, 0);
//	obj->vyaw = 3000;
//		obj->vpitch = 1000;
//		objtable.insert(obj);
	}
	printf("obj loaded\n");

	eye.set_view(viewport);

	printf("set view\n");
	
	struct timeval now;
	struct timeval then;
	gettimeofday(&then, 0);
	while(true) {
/*
		uchar cmd;
		if(mbuf->can_read()) {
			mbuf->read(cmd);
			switch(cmd) {
			case Sr3d::QUIT:	
				goto done;
			default:
				;
			}
		}
*/
		int key;
		while((key = viewport.get_key())) {
			switch(key) {
			case 'd':
				viewport.set_dither(!viewport.dither_set());
				break;
			case 'g':
				viewport.set_gourad(!viewport.gourad_set());
				break;
			case 'z':
				viewport.set_zbuf(!viewport.zbuf_set());
				break;
			case 'w':
				viewport.set_wireframe(
					!viewport.wireframe_set());
				break;
			case '0': num = 0; break;
			case '1': num = 1; break;
			case '2': num = 10; break;
			case '3': num = 100; break;
			case '4': num = 1000; break;
			case '5': num = 10000; break;
			case 'q': goto done;
			case 'h': eye.obj->vel += IVector(-1,0,0); break;
			case 'j': eye.obj->vel += IVector(0,1,0); break;
			case 'k': eye.obj->vel += IVector(0,-1,0); break;
			case 'l': eye.obj->vel += IVector(1,0,0); break;
			case 'i': eye.obj->vel += IVector(0,0,-1); break;
			case 'm': eye.obj->vel += IVector(0,0,1); break;
			}
		}
		viewport.clear();
		eye.set_transform();
		gettimeofday(&now, 0);
		int msec = (now.tv_sec-then.tv_sec)*1000
			+ (now.tv_usec-then.tv_usec)/1000;
		then = now;
		Obj3dIterator optr(objtable); 
		Obj3d *obj;
		while((obj = optr)) {
			obj->update(msec);
			obj->render(eye, light);
			optr++;
		}
		if(viewport.read_mouse(&mouse)) {
			IVertex cv[4] = {
				IVertex(mouse.x-10,mouse.y,0, 65535, 0, 0),
				IVertex(mouse.x,mouse.y-10,0, 0,65535, 0),
				IVertex(mouse.x+10,mouse.y,0, 0, 0, 65535),
				IVertex(mouse.x,mouse.y+10,0, 0, 32767, 32767)
			};
			for(int n=0; n<4; n++) {
				cv[n].x = uint(cv[n].x+3200000)%320;
				cv[n].y = uint(cv[n].y+2400000)%200;
			}
			viewport.fill_polygon(cv, 4);
		}
		if(vfx1.hmd_puck_update()) {
			printf("puck stuff\n"); fflush(stdout);
			angle_t yaw = vfx1.hmd_yaw();
			angle_t pitch = vfx1.hmd_pitch();
			angle_t roll = vfx1.hmd_roll();

			// eye.w = Vector(-dsin(-yaw), 0, dcos(-yaw));
			// eye.u = Vector(0, -dcos(pitch), -dsin(pitch));
			// eye.normalize();

			printf("lines\n"); fflush(stdout);
			viewport.line(100,100,
					100-vfx1.hmd_x()/82,
					100-vfx1.hmd_y()/82,
				0,0, Color(65535,0,0), Color(65535,0,0));
			viewport.line(200,50,
				200+isin(vfx1.hmd_pitch(), 50),
				50+icos(vfx1.hmd_pitch(), 50),
				0,0, Color(65535,0,0), Color(0,65535,0));
			viewport.line(300,50,
				300+isin(vfx1.hmd_roll(), 50),
				50+icos(vfx1.hmd_roll(), 50),
				0,0, Color(65535,0,0), Color(0,0,65535));

			printf("rotating\n"); fflush(stdout);
			Matrix4x4 trans = Matrix_Rotate_z(roll)
					* Matrix_Rotate_x(pitch)
					* Matrix_Rotate_y(yaw);
			Vector w = Vector(0,0,80)*trans;
			Vector u = Vector(0,80,0)*trans;
			Vector v = Vector(80,0,0)*trans;
			printf("lines\n"); fflush(stdout);
			viewport.line(160,100,int(w.x)+160,int(w.y)+100,0,int(w.z)+200,
				Color(65535,65535,65535), Color(65535,0,0));
			viewport.line(160,100,int(u.x)+160,int(u.y)+100,0,int(u.z)+200,
				Color(65535,65535,65535), Color(0,65535,0));
			viewport.line(160,100,int(v.x)+160,int(v.y)+100,0,int(v.z)+200,
				Color(65535,65535,65535), Color(0,0,65535));
			// eye.obj->vel = Vector(0, 0, vfx1.puck_pitch()*2);
			printf("puck stuff done\n"); fflush(stdout);
		}
		for(int q=0; q<num; q++) {
		IVertex iv[] = {
			//IVertex(i*q+160,i,0, 	65535,0,0),
			//IVertex(10-i*q,20-i,10, 	0,65535,0),
			//IVertex(80+i,10-i*q,15,	0,0,65535),
			//IVertex(30-i*q,80+i*q,20,	0,32767,32767)
			IVertex(i*q+160,i,0, 	65535,0,0),
			IVertex(10-i*q,20-i,10, 0,0,0),
			IVertex(80+i,10-i*q,15,	32767,0,0),
			IVertex(30-i*q,80+i*q,20, 0,0,8000)
		};
		for(int n=0; n<4; n++) {
			iv[n].x = uint(iv[n].x+3200000)%320;
			iv[n].y = uint(iv[n].y+2400000)%200;
		}
		viewport.fill_polygon(iv, 4);
		}
		if(!(viewport.framecount() & 0x3f & 0)) {
			char buf[80];
			f = viewport.fps_x1000();
			sprintf(buf, "%03d.%03d", f/1000, f%1000);
			screen.write(0,232,buf,
				screen.colormap()->match(
				Color(40000,20000,20000)), 0);
		}
		strncpy(buf, &msg[mpos], 40);
		buf[40]= '\0';
		if(++mpos >= msize-40)
			mpos = 0;
		screen.write(0, 224, buf,
			screen.colormap()->match(Color(4000,32000,50000)), 0);
		screen.write(12, 232, "'ShagRend3d' (c) 1995 C.S.H.",
					tcolor, 1);
		if(++tcolor >= 252)
			tcolor = 0;

#if 0
	IVertex iv[4] = { IVertex(20,20,0, 65535,0,0),
			  IVertex(300,20,0, 0,65535,0),
			  IVertex(300,180,0, 0,0,65535),
			  IVertex(20,180,0, 32767,0,32767) };
	viewport.draw_polygon(iv,4);
#endif
		viewport.update();
		i++;
	}
done: 
	f = viewport.fps_x1000();
	printf("fps = %d.%03d\n", f/1000, f%1000);
}


main(int argc, char **argv)
{
Membuf_fd mbuf(STDIN_FILENO);
	sr3d(&mbuf, argv[1]);
}

